#include "stdafx.h"
#include "testgetfile.h"
#include "testgetfileDlg.h"


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


#pragma warning(suppress: 26455)
CTestgetfileDlg::CTestgetfileDlg(_In_opt_ CWnd* pParent) : CDialog{CTestgetfileDlg::IDD, pParent},
                                                           m_sFilename{_T("bla")},
                                                           m_hIcon{AfxGetApp()->LoadIcon(IDR_MAINFRAME)}
{
}

void CTestgetfileDlg::DoDataExchange(CDataExchange* pDX)
{
  __super::DoDataExchange(pDX);
  DDX_Control(pDX, IDC_NONEMPTY, m_ctrlNotEmpty);
  DDX_Control(pDX, IDC_ENABLED, m_ctrlEnabled);
  DDX_Control(pDX, IDC_OVERWRITE_PROMPT, m_ctrlOverwritePrompt);
  DDX_Control(pDX, IDC_FILE_MUST_EXIST, m_ctrlFileMustExist);
  DDX_Control(pDX, IDC_AUTOCOMPLETE, m_ctrlAutoComplete);
  DDX_Control(pDX, IDC_READONLY, m_ctrlReadOnly);
  DDX_Control(pDX, IDC_VISIBLE, m_ctrlVisible);
  DDX_FilenameControl(pDX, IDC_FILENAME, m_ctrlGetFilename);
  DDX_FilenameValue(pDX, m_ctrlGetFilename, m_sFilename);
  DDV_FilenameControlNotFolder(pDX, m_ctrlGetFilename, IDP_DDXFILE_REQUIRE_VALID_FILE);
  if (m_ctrlOverwritePrompt.GetCheck())
    DDV_FilenameControlOverwritePrompt(pDX, m_ctrlGetFilename);
  if (m_ctrlFileMustExist.GetCheck())
    DDV_FilenameControlMustExist(pDX, m_ctrlGetFilename, IDP_DDXFILE_REQUIRE_VALID_FILE);
  if (m_ctrlNotEmpty.GetCheck())
    DDV_FilenameControlNotEmpty(pDX, m_ctrlGetFilename, IDP_DDXFILE_REQUIRE_VALID_FILE);
}

#pragma warning(suppress: 26433 26440)
BEGIN_MESSAGE_MAP(CTestgetfileDlg, CDialog) //NOLINT(modernize-avoid-c-arrays)
  ON_WM_PAINT()
  ON_WM_QUERYDRAGICON()
  ON_BN_CLICKED(IDC_FILE_MUST_EXIST, &CTestgetfileDlg::OnFileMustExist)
  ON_BN_CLICKED(IDC_OVERWRITE_PROMPT, &CTestgetfileDlg::OnOverwritePrompt)
  ON_BN_CLICKED(IDC_READONLY, &CTestgetfileDlg::OnReadonly)
  ON_BN_CLICKED(IDC_ENABLED, &CTestgetfileDlg::OnEnabled)
  ON_BN_CLICKED(IDC_AUTOCOMPLETE, &CTestgetfileDlg::OnAutoComplete)
  ON_BN_CLICKED(IDC_VISIBLE, &CTestgetfileDlg::OnVisible)
END_MESSAGE_MAP()

BOOL CTestgetfileDlg::OnInitDialog()
{
  //Let the base class do its thing
  __super::OnInitDialog();

  SetIcon(m_hIcon, TRUE);
  SetIcon(m_hIcon, FALSE);

  //By default check the "Enabled" and visible check boxes
  m_ctrlEnabled.SetCheck(1);
  m_ctrlVisible.SetCheck(1);
  m_ctrlAutoComplete.SetCheck(m_ctrlGetFilename.GetAutoComplete());

  //Call the various event handles to ensure that the flags in the control are in sync with the UI
  OnEnabled();
  OnFileMustExist();
  OnOverwritePrompt();
  OnReadonly();
  
  return TRUE;
}

#pragma warning(suppress: 26434)
void CTestgetfileDlg::OnPaint()
{
  if (IsIconic())
  {
    CPaintDC dc{this};

#pragma warning(suppress: 26490)
    SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

    //Center icon in client rectangle
    const int cxIcon{GetSystemMetrics(SM_CXICON)};
    const int cyIcon{GetSystemMetrics(SM_CYICON)};
    CRect rect;
    GetClientRect(&rect);
    const int x{(rect.Width() - cxIcon + 1) / 2};
    const int y{(rect.Height() - cyIcon + 1) / 2};

    //Draw the icon
    dc.DrawIcon(x, y, m_hIcon);
  }
  else
    __super::OnPaint();
}

#pragma warning(suppress: 26434 26440)
HCURSOR CTestgetfileDlg::OnQueryDragIcon()
{
#pragma warning(suppress: 26473)
  return static_cast<HCURSOR>(m_hIcon);
}

void CTestgetfileDlg::OnFileMustExist()
{
  DWORD dwFlags{m_ctrlGetFilename.GetCommonDialogFlags()};
  if (m_ctrlFileMustExist.GetCheck())
    dwFlags |= OFN_FILEMUSTEXIST;
  else
    dwFlags &= ~OFN_FILEMUSTEXIST;

  m_ctrlGetFilename.SetCommonDialogFlags(dwFlags);
}

void CTestgetfileDlg::OnOverwritePrompt() 
{
  DWORD dwFlags{m_ctrlGetFilename.GetCommonDialogFlags()};
  if (m_ctrlOverwritePrompt.GetCheck())
    dwFlags |= OFN_OVERWRITEPROMPT;
  else
    dwFlags &= ~OFN_OVERWRITEPROMPT;
  m_ctrlGetFilename.SetCommonDialogFlags(dwFlags);
}

void CTestgetfileDlg::OnReadonly()
{
  m_ctrlGetFilename.SetReadOnly(m_ctrlReadOnly.GetCheck() == 1);
}

void CTestgetfileDlg::OnEnabled() 
{
  m_ctrlGetFilename.EnableWindow(m_ctrlEnabled.GetCheck() == 1);
}

void CTestgetfileDlg::OnAutoComplete()
{
  m_ctrlGetFilename.SetAutoComplete(m_ctrlAutoComplete.GetCheck() == 1);
}

void CTestgetfileDlg::OnVisible()
{
  m_ctrlGetFilename.ShowWindow(m_ctrlVisible.GetCheck() == 1 ? SW_SHOW : SW_HIDE);
}
